Dancer2::Serializer::JSON(3pm)

NAME
Dancer2::Serializer::JSON - Serializer for handling JSON data

VERSION
version 2.1.0

DESCRIPTION
This is a serializer engine that allows you to turn Perl data structures into JSON output and vice-versa.

ATTRIBUTES

  content_type
Returns 'application/json'

METHODS

  serialize($content)
Serializes a Perl data structure into a JSON string.

  deserialize($content)
Deserializes a JSON string into a Perl data structure.

FUNCTIONS

  from_json($content, \%options)
This is an helper available to transform a JSON data structure to a Perl data structures.

  to_json($content, \%options)
This is an helper available to transform a Perl data structure to JSON.

Calling this function will not trigger the serialization's hooks.

  Configuring the JSON Serializer using "set engines"
The JSON serializer options can be configured via "set engines". The most common settings are:

allow_nonref
    Ignore non-ref scalars returned from handlers. With this set the "Hello, World!" handler returning a string will be dealt with properly.

strict_utf8
    If true, invalid UTF-8 bytes in data passed to the JSON encoder will cause an error. If false (default), invalid bytes are left as-is and a warning is logged.

Note: the "utf8" option is forced to true internally to ensure JSON output is UTF-8 encoded bytes.

Set engines should be called prior to setting JSON as the serializer:

 set engines =>
 {
     serializer =>
     {
         JSON =>
         {
            allow_nonref => 1
         },
     }
 };

 set serializer      => 'JSON';
 set content_type    => 'application/json';

  Returning non-JSON data.
Handlers can return non-JSON via "send_as", which overrides the default serializer:

 get '/' =>
 sub
 {
     send_as html =>
     q{Welcome to the root of all evil...<br>step into my office.}
 };

Any other non-JSON returned format supported by 'send_as' can be used.

AUTHOR
Dancer Core Developers

COPYRIGHT AND LICENSE
This software is copyright (c) 2026 by Alexis Sukrieh.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.